﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Collections;
using Infragistics.Controls.Grids;

namespace XamGridCheckBoxColumnSelectAll
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<DummyData> _data;

        public MainWindow()
        {
            InitializeComponent();
            this.grid1.ItemsSource = Data;
        }


        public IEnumerable Data
        {
            get
            {
                if (this._data == null)
                {
                    this._data = new ObservableCollection<DummyData>();
                    for (int i = 0; i < 2000; i++)
                    {
                        this._data.Add(new DummyData() { IsSelect = false, Data = "Data: " + i.ToString() });
                    }
                }
                return this._data;
            }
        }

        private void CheckBox_Click(object sender, RoutedEventArgs e)
        {
            CheckBox cb = (CheckBox)sender;

            foreach (RowBase row in this.grid1.Rows[0].Manager.Rows)
            {
                if (row.RowType == RowType.DataRow)
                {
                    ((DummyData)row.Data).IsSelect = (bool)cb.IsChecked;
                }
            }
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            List<DummyData> data = new List<DummyData>();

            foreach (RowBase row in this.grid1.Rows[0].Manager.Rows)
            {
                if (row.RowType == RowType.DataRow)
                {
                    if (((DummyData)row.Data).IsSelect == true)
                    {
                        data.Add((DummyData)row.Data);
                    }
                }
            }

            List<DummyData> selectedRows = data;
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            List<DummyData> data = new List<DummyData>();

            foreach (RowBase row in this.grid1.Rows[0].Manager.Rows)
            {
                if (row.RowType == RowType.DataRow)
                {
                    if (((DummyData)row.Data).IsSelect == true)
                    {
                        data.Add((DummyData)row.Data);
                    }
                }
            }

            int count = data.Count;
        }



    }

    public class DummyData : INotifyPropertyChanged
    {
        bool isSelect;
        string data;

        public bool IsSelect
        {
            get
            {
                return this.isSelect;
            }

            set
            {
                if (value != this.isSelect)
                {
                    this.isSelect = value;
                    NotifyPropertyChanged("IsSelect");
                }
            }
        }

        public string Data
        {
            get
            {
                return this.data;
            }

            set
            {
                if (value != this.data)
                {
                    this.data = value;
                    NotifyPropertyChanged("Data");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
    }
}
